Shader "Custom/Mask" {
   
    SubShader {
        // Render the mask after regular geometry, but before masked geometry and
        // transparent things.
       
        Tags {"Queue" = "Transparent+10" }
       
        // Don't draw in the RGBA channels; just the depth buffer
       	Lighting Off
       	AlphaTest Off
        ColorMask 0
        ZWrite On
        Cull Off
       
        // Do nothing specific in the pass:
       
        Pass {}
    }
}