using UnityEngine;
using System.Collections;

public class Editor : MonoBehaviour {
	
	private Level level;
	public static bool editmode=false;
	
	public enum EditTool {
		Block,
		Player,
		Collectable
	}
	public EditTool tool;		
	
	public const string blanklevel = "1|-1,0,0|0|-1,0,0^0|1|0.5486156~0.7980117~0.2493961";
	
#if UNITY_EDITOR
	/*
	// Use this for initialization
	void Awake () {
		level = GetComponent<Level>();
	}
	
	private void LogEditorState ()
	{
		Debug.Log(editmode + " - " + tool);
	}
	
	
	// Update is called once per frame
	void Update ()
	{
		if (Application.isEditor == false)
		{
			return;
		}
		
		if (Input.GetKeyDown(KeyCode.P))
		{
			level.PlacePlayerAndCollecatbles();
		}
			
		if (Input.GetKeyDown(KeyCode.Q))
		{
			editmode = true;
			tool = Editor.EditTool.Block;
			LogEditorState();
		}
		if (Input.GetKeyDown(KeyCode.W))
		{
			editmode = true;
			tool = Editor.EditTool.Player;
			LogEditorState();
		}
		if (Input.GetKeyDown(KeyCode.E))
		{
			editmode = true;
			tool = Editor.EditTool.Collectable;
			LogEditorState();
		}
		
		if (Input.GetKeyDown(KeyCode.C))
		{
			level.Jitter();
			string dat = level.Serialize();
			level.Deserialize(dat);
			Debug.Log(dat);
			UnityEditor.EditorGUIUtility.systemCopyBuffer = dat;
		}
		if (Input.GetKeyDown(KeyCode.V))
		{
			level.Deserialize(UnityEditor.EditorGUIUtility.systemCopyBuffer);
		}
		if (Input.GetKeyDown(KeyCode.N) || Input.GetKeyDown(KeyCode.B))
		{
			level.Deserialize(blanklevel);
		}	
		
		if (Input.GetKeyDown(KeyCode.Tab))
		{
			editmode = !editmode;
			if (editmode == false)
			{
				Camera.mainCamera.GetComponent<MouseOrbit>().Target();
				Camera.mainCamera.GetComponent<MouseOrbit>().Snap();
			}
			else
			{
				level.ShowInvisibleCollectables();
			}
		}
		
		if (editmode == false)
		{
			return;
		}
		var ray = Camera.main.ScreenPointToRay(Input.mousePosition);
		RaycastHit hit;
		if (Physics.Raycast(ray, out hit, 1000, 1 << 10))
		{
			Debug.DrawRay(hit.point, hit.normal, Color.black);
			Face f = level.GetFaceFromNormalRay(hit.point, hit.normal);
			Debug.DrawRay(f.Center(), DodecaData.SideNormal [f.side], Color.white);
			
			if (Input.GetMouseButtonDown(0))
			{
				switch (tool)
				{
					case EditTool.Block:
						BlockEdit(f);
						break;
					case EditTool.Collectable:
						CollectableEdit(f);
						break;
					case EditTool.Player:
						PlayerEdit(f);
						break;
				}
			}
		}
	}
	
	private void BlockEdit (Face f)
	{
		if (Input.GetKey(KeyCode.LeftShift))
		{
			Coord c = f.coord;
			level.points.Remove(c);
		}
		else
		{
			Coord c = f.NormalCoord();
			level.points.Add(c);
		}
		level.Regen();
	}
	
	private void CollectableEdit (Face f)
	{
		if (Input.GetKey(KeyCode.LeftShift))
		{
			level.collectables.Remove(f);
		}
		else
		{
			if (level.collectables.IndexOf(f) < 0)
			{
				level.collectables.Add(f);
			}		
		}
		level.SpawnCollectables();
		
	}
	
	private void PlayerEdit (Face f)
	{
		level.playerface = f;
		GetComponent<Controller>().SnapPlayer();
	}*/
#endif
}
