using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class PieceMask : MonoBehaviour {		
	private MeshFilter mf;
	
	private static Mesh mymesh = null;
	void Awake ()
	{		
		mf = GetComponent<MeshFilter>();
		
		if (mymesh == null)
		{
			GenStaticMesh();
		}
		
		mf.sharedMesh = mymesh;
	}
	
	public const float contractamount = 1.0f;
	
	private static Vector3[] vertices = {
			new Vector3(-2 * 0.713f, 0, 0) * contractamount,
			new Vector3(0, 0, 1) * contractamount,
			new Vector3(2 * 0.713f, 0, 0) * contractamount,
			new Vector3(0, 0, -1) * contractamount,
		};
	
	public void GenStaticMesh ()
	{
		if (mf == null)
		{			
			mf = GetComponent<MeshFilter>();
		}
		MeshData md = new MeshData();
		md.AddQuad(vertices [0], vertices [1], vertices [2], vertices [3]);
		
		mymesh = md.BuildSingleMesh_Dangerous(false, true);
	}
}
