using UnityEngine;
using System.Collections;

public class ScaleUp : MonoBehaviour {
	
	private Vector3 from_scale;
	public Vector3 target_scale = Vector3.one*0.0f;
	public float duration = 1.0f;
	
	private float time = 0;
		
	void Start ()
	{
		from_scale = transform.localScale;
	}
	
	// Update is called once per frame
	void Update ()
	{
		time += Time.deltaTime;
		if (time <= duration)
		{
			transform.localScale = Vector3.Lerp(from_scale, target_scale, time / duration);
		}
		else
		{
			Destroy(gameObject);
		}
	}
}
