Shader "Custom/Player Static" {
    Properties {
        _Color ("Color", Color) = (0.5,0.5,0.5,0.5)
    }

    SubShader {
        Tags { "Queue" = "Geometry" }
        //Blend SrcAlpha OneMinusSrcAlpha
        //AlphaTest Greater .01
        ColorMask RGB
        Lighting Off
        AlphaTest Off
        ZWrite On
        Cull Off

        Pass {
            CGPROGRAM
// Upgrade NOTE: excluded shader from Xbox360; has structs without semantics (struct v2f members uv,color)
#pragma exclude_renderers xbox360
                #pragma vertex vert
                #pragma fragment frag
                #pragma multi_compile_builtin
                #pragma fragmentoption ARB_precision_hint_fastest
                #include "UnityCG.cginc"
               
                uniform float4  _Color;          

                struct appdata_vert {
                    float4 vertex : POSITION;
                };
                              
                struct v2f {
                    float4 pos : SV_POSITION;
                };
               
                v2f vert (appdata_vert v) {
                    v2f o;
                    o.pos = mul (UNITY_MATRIX_MVP, v.vertex);
                    return o;
                }
               
                float4 frag (v2f i) : COLOR {                   
                    return _Color;
                }
            ENDCG
        }
    }
   
	Fallback " VertexLit", 1
}
 