// Unlit alpha-blended shader.
// - no lighting
// - no lightmap support
// - no per-material color

Shader "Unlit/Transparent with tint" {
Properties {
	_MainTex ("Base (RGB) Trans (A)", 2D) = "white" {}
 	_Color ("Main Color", Color) = (1,1,11)
 }

SubShader {
	Tags {"Queue"="Transparent-60" "IgnoreProjector"="True" "RenderType"="Transparent"}
	LOD 100
	
	Blend SrcAlpha OneMinusSrcAlpha 
	Lighting Off
	Cull Off
	ZWrite Off
		
	Color [_Color]
	Pass {
		SetTexture [_MainTex] { 
		                constantColor [_Color]
		                Combine  texture *constant
		   } 
	}
}
}