using UnityEngine;
using System.Collections;

public class FadeAndDie : MonoBehaviour {

	public const float dietime = 1.0f;
	private float time=0;
	public bool last=false;
	public Level level;
	
	void Update ()
	{
		time += Time.deltaTime;
		
		if (time >= dietime)
		{		
			if (last == true)
			{
				level.levelcompletetext.gameObject.SetActiveRecursively(true);
				TitleOptions.curlevel++;
				level.leaving = true;
				//play sound effect
				if (TitleOptions.curlevel >= LevelData.LevelDats.Length)
				{
					TitleOptions.curlevel--;
					FadeAndLoadLevel.FadeSlow("EndingScene");
				}
				else
				{
					SaveManager.SetProgress(TitleOptions.curlevel);
					FadeAndLoadLevel.FadeSlow("MainScene");
				}
			}
			DestroyImmediate(gameObject);
		}
		else
		{
			float f = (dietime - time) / dietime;
			f = f * f;
			transform.localScale = Vector3.one * f;
		}

	}
}
