using UnityEngine;
using System.Collections;

public class QuitButton : MonoBehaviour {
	
	public Level level;
	Camera cam;
	// Use this for initialization
	void Start ()
	{
		if (Application.platform != RuntimePlatform.IPhonePlayer)
		{
			DestroyImmediate(gameObject);
		}
		cam = Camera.mainCamera;
	}
	
	// Update is called once per frame
	void Update ()
	{	
		if (Input.GetMouseButtonDown(0) && level.leaving == false)
		{
			Ray ray = cam.ScreenPointToRay(Input.mousePosition);
			RaycastHit hit;
			if (Physics.Raycast(ray, out hit, 1000, 1 << 8))
			{
				renderer.material.color= Color.white;
				level.leaving = true;
				FadeAndLoadLevel.Fade("TitleScene");
			}
		}
	}
}
