using UnityEngine;
using System.Collections;

//[ExecuteInEditMode]
public class ScreenRelativePosition : MonoBehaviour {
	
	public Vector3 ViewportPosition = new Vector3(1, 1, 5);
	public Vector3 WorldOffset = new Vector3(0,0,0);
	
	// Use this for initialization
	void Start ()
	{
		Reposition();
	}	
	
	void Reposition ()
	{		
		Camera 	cam = Camera.mainCamera;
		transform.position = cam.ViewportToWorldPoint(ViewportPosition) + WorldOffset;
	}
		
#if UNITY_EDITOR
	//should move this to separate GO but whatever
	void Update ()
	{
		if (UnityEditor.EditorApplication.isPlaying==false)
		{
			Reposition();
		}
	}
#endif
	
}
