using UnityEngine;
using System.Collections;

public class EndButton : MonoBehaviour {

	// Use this for initialization
	void Start ()
	{
	
	}
	private bool fading=false;
		
	// Update is called once per frame
	void Update ()
	{
		if (fading)
		{
			return;
		}
		
		Ray ray = Camera.mainCamera.ScreenPointToRay(Input.mousePosition);
		RaycastHit hit;
		if (Physics.Raycast(ray, out hit, 1000, 1 << 8))
		{		
			if (Input.GetMouseButtonDown(0))
			{
				fading = true;
				FadeAndLoadLevel.Fade("TitleScene");
				transform.GetChild(0).renderer.material.color = TitleOptions.down;				
			}
			else
			{
				transform.GetChild(0).renderer.material.color = TitleOptions.highlighted;
			}
		}
		else
		{
			transform.GetChild(0).renderer.material.color = TitleOptions.normal;			
		}

	}
}
